REM  *****  BASIC  *****

REM *********************************  BASIC  ***************************************
REM *																				*
REM *	Auflistung aller im Dokument vorhandenen Fussnoten in einer Calc-Tabelle	*
REM *																				*
REM *********************************************************************************
Sub FussnotenExport
Dim oDocC as Object
Dim oDocW as Object
Dim oSheet as Object
Dim oRange as Object
Dim oAnchor as Object

Dim sPath as String
Dim mArr() as Variant
Dim oCol as Object
Dim i as Long

   	' Hier in der Basic-IDE -> Objektkatalog
	' LibreOffice Makros & Dialoge -> Tools
	Globalscope.BasicLibraries.LoadLibrary ( "Tools")
	' Referenz: aktuelles Dokument
    oDocW = ThisComponent

REM ----------------------------------------------------------------------------------------
REM Errorhandling: Fokus
    ' Prfung: Ist das aktuelle Dokument ein Writer-Dokument? 
    ' Wenn nicht, dann Programm nach Meldung beenden.
    If getDocType(oDocW) = "unknown" then 
    	 MsgBox "Das aktuelle Dokument ist kein Writer-Dokument!" & chr(10) &_
    				"Bitte ffnen Sie das gewnschte Writer-Dokument, stellen den Cursor" & chr(10) &_
    					"in eine der Zeilen und starten das Makro erneut." & chr(10) &_
	    					"Das Programm wird beendet.", 48, "Fehler: Dokument oder Applikation unbekannt!"
			' Programm beenden
			Exit Sub
    End If 

    ' Prfung: Ist das aktuelle Dokument ein Writer-Dokument? 
    ' Wenn nicht, dann Programm nach Meldung beenden.
	If NOT oDocW.supportsService("com.sun.star.text.TextDocument") Then
    	MsgBox "Das aktuelle Dokument ist kein Writer-Dokument!" & chr(10) &_
    				"Bitte ffnen Sie das gewnschte Writer-Dokument, stellen den Cursor" & chr(10) &_
    					"in eine der Zeilen und starten das Makro erneut." & chr(10) &_
	    					"Das Programm wird beendet.", 48, "Fehler: Kein Writer-Dokument"
			' Programm beenden
			Exit Sub	
	End If

'    mri oDocW
    ' URL des aktuellen Dokuments ermitteln
    sPath=oDocW.Location
    ' URL in Pfadangabe wandeln
    sPath=convertfromURL(sPath)
    ' Prfung: Wurde das Dokument schon mal gespeichert?
    ' Wenn nicht, dann Programm nach Meldung beenden.
    If sPath = "" Then 
    	MsgBox "Das Writer-Dokument wurde noch nicht gespeichert!" & chr(10) &_
					"Bitte speichern Sie das Dokument und starten das Makro erneut." & chr(10) &_    	
   						"Das Programm wird beendet.", 32, "Dokument muss zuvor gespeichert werden!"
			' Programm beenden
			Exit Sub
	End If		

REM ----------------------------------------------------------------------------------------
	oCC=oDocW.CurrentController
		oVC = oCC.getViewCursor
	
    ' Referenz: Funoten-Objekt
    oFN=oDocW.Footnotes
    ' Prfung: Sind Funoten im Dokument enthalten?
    ' Wenn nicht, dann Programm nach Meldung beenden.
    If oFN.Count = 0 Then 
    	MsgBox "Im Writer-Dokument sind keine Funoten enthalten!" & chr(10) &_
   					"Das Programm wird beendet.", 32, "Keine Funoten!"
			' Programm beenden
			Exit Sub
	End If		

    oFNSettings = oDocW.getFootnoteSettings()
    'ffnen eines Calc-Dokuments
    oDocC = StarDesktop.loadComponentFromURL("private:factory/scalc","_blank", 0, Array())
    'Referenzierung der "Tabelle 1"
    oSheet = oDocC.Sheets(0)
'mri oDocC
'mri oSheet
	' Tabellenblatt formatieren
	With oSheet
        .Name="Funotenliste" 
        .CharFontName="Times New Roman"
        .CharHeight=10       
	End With

REM ----------------------------------------------------------------------------------------------
REM Seite skalieren
 s = oDocC.CurrentController.getActiveSheet().PageStyle
  oStyle = oDocC.StyleFamilies.getByName("PageStyles").getByName(s)
  oStyle.PageScale = 75		' ---> 85%

	StyleFamilies = oDocC.StyleFamilies
	PageStyles = StyleFamilies.getByName("PageStyles")
		DefPage = PageStyles.getByName("Default")
'mri defpage	
REM ----------------------------------------------------------------------------------------------
REM Seite formatieren
		With Defpage
REM................................................
REM Querformat
'			.IsLandscape = True
'			.Width = 29700
'			.Height = 21000
'			.TopMargin=1000
'			.BottomMargin=500
'			.LeftMargin=500
'			.RightMargin=500
REM............................................
REM Hochformat
			.IsLandscape = False
			.Width = 21000
			.Height = 29700
			.TopMargin=1000
			.BottomMargin=500
			.LeftMargin=1500
			.RightMargin=500
REM............................................			
			.HeaderIsOn=True
			.HeaderIsShared = True
			.CenterHorizontally=True
			.CenterVertically=False
'			.PageScale=75
		End With
'mri oFN(1)
    'Zellbereich A:C zwecks Dimensionierung des Array's in das Array schreiben
    mArr()=osheet.getcellrangebyposition(0,1,3,oFN.Count).getDataArray
    
REM ----------------------------------------------------------------------------------------
REM Fussnoten auslesen
	For i = 0 To oFN.Count-1

			' Spalte A 
			mArr(i)(0) = oFN(i).Anchor.String
'			mri oFN(i)
			' Spalte C
			mArr(i)(2) = oFN(i).String
			' Spalte D
			oAnchor=oFN(i).anchor
			If isempty(oAnchor.cell) Then
				'im normalen Text
				oTxt=oAnchor.text
			Else
				'in einer Tabellenzelle
				oTxt=oAnchor.cell
			End If
			ocur=otxt.createtextcursorbyrange(oAnchor)
			ocur.collapsetostart
			ocur.gotostartofparagraph(true)
			mArr(i)(3) = ocur.string
			
			' Spalte B
			' Zwecks Ermittlung der Seitenzahl, auf der sich die aktuelle Funote befindet,
			' wird der Textcursor an den Viewcursor bergeben. 
			' Grund: Der Textcursor verfgt nicht ber die Methode	"getPage()"
			oVC.gotoRange(ocur,false)
						mArr(i)(1) = oVC.getPage()
	Next i

REM ----------------------------------------------------------------------------------------
REM Referenz Range-Objekt (Zellbereich)
    oRange = osheet.getcellrangebyposition(0,1,3,oFN.Count)   
	with oRange
	    'Array in Zellbereich schreiben
		.setDataArray(mArr)
		
	End With
    'Spaltenberschrift einfgen und formatieren
	With oSheet
        .getCellRangeByName("A1").String="Index"
        .getCellRangeByName("B1").String="Seite"
        .getCellRangeByName("C1").String="Fussnoten"
        .getCellRangeByName("D1").String="Absatz: Inhalt"
        .getCellRangeByName("A1").CharWeight = com.sun.star.awt.FontWeight.BOLD        
        .getCellRangeByName("B1").CharWeight = com.sun.star.awt.FontWeight.BOLD
        .getCellRangeByName("C1").CharWeight = com.sun.star.awt.FontWeight.BOLD
        .getCellRangeByName("D1").CharWeight = com.sun.star.awt.FontWeight.BOLD
        .getCellRangeByName("A1").HoriJustify=com.sun.star.table.CellHoriJustify.CENTER
		.getCellRangeByName("B1").HoriJustify=com.sun.star.table.CellHoriJustify.CENTER
		.getCellRangeByName("C1").HoriJustify=com.sun.star.table.CellHoriJustify.CENTER
		.getCellRangeByName("D1").HoriJustify=com.sun.star.table.CellHoriJustify.CENTER
        .getCellRangeByName("A1").charcolor = &H000000
        .getCellRangeByName("B1").charcolor = &H000000 
        .getCellRangeByName("C1").charcolor = &H000000
        .getCellRangeByName("D1").charcolor = &H000000
    End With
    'Spaltenbreite anpassen
    oCol = oSheet.getColumns()
	' Text in Zelle vertikal zentrieren
	oRange.VertJustify= 2
	
	'Spalte A formatieren
	oColA = oCol.getbyname("A")
	oColA.VertJustify= 2
	oColA.HoriJustify=com.sun.star.table.CellHoriJustify.CENTER

	'Spalte B formatieren
	oColB = oCol.getbyname("B")
	oColB.VertJustify= 2
	oColB.HoriJustify=com.sun.star.table.CellHoriJustify.CENTER

	' optimale Zellbreite
    oCol.optimalWidth = true
	' Refrenz Spalte "C"
    oColC = oCol.getbyname("C")
	' Spaltenbreite 8,0cm
'    oColC.Width=8000
	' Spaltenbreite 5,5cm
    oColC.Width=5500
    ' Zeilenumbruch einstellen
    oColC.IsTextWrapped= True

    ' Refrenz Spalte "D"
    oColD = oCol.getbyname("D")
	' Spaltenbreite 20,5cm
'    oColD.Width=20500
	' Spaltenbreite 15,0cm
    oColD.Width=15000
    ' Zeilenumbruch einstellen
    oColD.IsTextWrapped= True
' Zellumrandung zeichnen
dim linestyle as new com.sun.star.table.BorderLine
	linestyle.Color = RGB(0, 0, 0)
	linestyle.OuterLineWidth = 40
	borders = array("TopBorder", "LeftBorder", "RightBorder", "BottomBorder")
	styles = array(linestyle,linestyle,linestyle,linestyle)
		oRange.setPropertyValues(borders , styles)
	
' Zeile 1 = Wiederholungszeile
Dim oRange2 as object
Dim CellRangeAddress as Object

	oRange2 = oSheet.getCellRangeByPosition(0,0,3,0)
	CellRangeAddress = oRange2.getRangeAddress()

		oSheet.setTitleRows(CellRangeAddress)

REM ----------------------------------------------------------------------------------------
REM >>> Inhalt Kopfzeile zuweisen <<<
HContent = defpage.RightPageHeaderContent 

' Kopfzeile zentriert
HText = HContent.CenterText
HText.setString("Verkndigung 4.0 Funotenliste")
'mri Htext

' rechte Seite
defpage.rightPageHeaderContent = HContent
' linke Seite
defpage.LeftPageHeaderContent=HContent


REM ----------------------------------------------------------------------------------------
REM >>> Inhalt Fuzeile zuweisen <<<
FContent = defpage.RightPageFooterContent 

'Fuzeile links >>> Datei- und Pfadangabe
'HText = FContent.LeftText
'HText.setstring(sPath)

'Fuzeile zentriert >>> leer
HText = FContent.CenterText
HText.setstring("")

'Fuzeile rechts >>> Seitenzahl
HText = FContent.RightText
oField = oDocC.createInstance("com.sun.star.text.TextField.PageNumber")
oCursor = HText.createTextCursor()
HText.insertTextContent(oCursor, oField, False)

' rechte Seite
defpage.rightPageFooterContent = FContent
' linke Seite
defpage.LeftPageFooterContent=FContent 

'mri defpage
'	Defpage.PageScale=85

End Sub

REM ----------------------------------------------------------------------------------------
REM Funktion prft welche Applikation den Fokus hat
Function getDocType(Optional vDoc) As String
  On Error GoTo Oops
  If IsMissing(vDoc) Then vDoc = ThisComponent
  If vDoc.SupportsService("com.sun.star.sheet.SpreadsheetDocument") Then
    getDocType = "Calc"
  ElseIf vDoc.SupportsService("com.sun.star.text.TextDocument") Then
    getDocType = "Writer"
  ElseIf vDoc.SupportsService("com.sun.star.drawing.DrawingDocument") Then
    getDocType = "Draw"
  ElseIf vDoc.SupportsService(_
                     "com.sun.star.presentation.PresentationDocuments") Then
    getDocType = "Presentation"
  ElseIf vDoc.SupportsService("com.sun.star.formula.FormulaProperties") Then
    getDocType = "Math"
  ElseIf vDoc.SupportsService("com.sun.star.sdb.OfficeDatabaseDocument") Then
    getDocType = "Base"
  Else
    getDocType = "unknown"
  End If
Oops:
  If Err <> 0 Then getDocType = "unknown"
  On Error GoTo 0   'Turn off error handling AFTER checking for an error
End Function
